package com.hai.goods.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.hai.dao.GoodsLogisticsMapper;
import com.hai.entity.GoodsLogistics;
import com.hai.entity.GoodsLogisticsExample;
import com.hai.goods.service.GoodsLogisticsService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;
import java.util.Map;

@Service("goodsLogisticsService")
public class GoodsLogisticsServiceImpl implements GoodsLogisticsService {

    @Resource
    private GoodsLogisticsMapper goodsLogisticsMapper;

    @Override
    public void insertGoodsLogistics(GoodsLogistics goodsLogistics) {
        goodsLogisticsMapper.insert(goodsLogistics);
    }

    @Override
    public void updateGoodsLogistics(GoodsLogistics goodsLogistics) {
        goodsLogisticsMapper.updateByPrimaryKey(goodsLogistics);
    }

    @Override
    public List<GoodsLogistics> getGoodsLogisticsList(Map<String, Object> map) {
        return null;
    }

    @Override
    public GoodsLogistics findGoodsLogisticsById(Long id) {
        return goodsLogisticsMapper.selectByPrimaryKey(id);
    }

    @Override
    public GoodsLogistics findGoodsLogisticsByNum(String num) {
        GoodsLogisticsExample example = new GoodsLogisticsExample();
        GoodsLogisticsExample.Criteria criteria = example.createCriteria();

        criteria.andNumberEqualTo(num).andStatusEqualTo(1);

        List<GoodsLogistics> logistics = goodsLogisticsMapper.selectByExample(example);

        if (logistics.size() > 0) {
            return logistics.get(0);
        }

        return null;
    }

    @Override
    public GoodsLogistics editLogistics(JSONObject jsonObject) {

        JSONObject info = (JSONObject) jsonObject.getJSONArray("info").get(0);

        GoodsLogistics logistics = findGoodsLogisticsByNum(info.getString("mailNo"));

        if (logistics == null) {
            logistics = new GoodsLogistics();
        }

        logistics.setTaskNo(jsonObject.getString("orderNo"));
        logistics.setTheLastTime(info.getDate("theLastTime"));
        logistics.setTheLastMessage(info.getString("theLastMessage"));
        logistics.setTakeTime(info.getString("takeTime"));
        logistics.setNumber(info.getString("mailNo"));
        logistics.setLogisticsStatus(info.getString("logisticsStatus"));
        logistics.setExpressCompanyName(info.getString("logisticsCompanyName"));
        logistics.setLogisticsStatusDesc(info.getString("logisticsStatusDesc"));
        logistics.setLogisticsTraceDetails(info.getString("logisticsTraceDetailList"));
        logistics.setStatus(1);

        if ( logistics.getId() == null) {
            logistics.setCreateTime(new Date());
            insertGoodsLogistics(logistics);
        } else {
            updateGoodsLogistics(logistics);
        }

        return logistics;
    }
}
