package com.hai.goods.service.impl;

import com.hai.dao.GoodsPresentMapper;
import com.hai.entity.GoodsPresent;
import com.hai.entity.GoodsPresentExample;
import com.hai.entity.GoodsRegionFreight;
import com.hai.goods.service.GoodsPresentService;
import org.apache.commons.collections4.MapUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

@Service("goodsPresentService")
public class GoodsPresentServiceImpl implements GoodsPresentService {

    @Resource
    private GoodsPresentMapper goodsPresentMapper;

    @Override
    public void insertPresent(GoodsPresent present) {
        goodsPresentMapper.insert(present);
    }

    @Override
    public void updatePresent(GoodsPresent present) {
        goodsPresentMapper.updateByPrimaryKey(present);
    }

    @Override
    public List<GoodsPresent> getPresentList(Map<String, Object> map) {
        GoodsPresentExample example = new GoodsPresentExample();
        GoodsPresentExample.Criteria criteria = example.createCriteria();

        if (MapUtils.getLong(map, "goodsId") != null) {
            criteria.andGoodsIdEqualTo(MapUtils.getLong(map, "goodsId"));
        }
        criteria.andStatusNotEqualTo(String.valueOf(0));

        return goodsPresentMapper.selectByExample(example);
    }

    @Override
    public GoodsPresent findPresentById(Long id) {
        return goodsPresentMapper.selectByPrimaryKey(id);
    }

    @Override
    public void deletePresent(Long id) {
        goodsPresentMapper.deleteByPrimaryKey(id);
    }
}
