package com.hai.goods.service.impl;

import com.hai.dao.GoodsSkuMapper;
import com.hai.entity.GoodsDetailExample;
import com.hai.entity.GoodsSku;
import com.hai.entity.GoodsSkuExample;
import com.hai.goods.service.GoodsSkuService;
import org.apache.commons.collections4.MapUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

@Service("goodsSkuService")
public class GoodsSkuServiceImpl implements GoodsSkuService {

    @Resource
    private GoodsSkuMapper goodsSkuMapper;

    @Override
    public void insertGoodsSku(GoodsSku goodsSku) {
        goodsSkuMapper.insert(goodsSku);
    }

    @Override
    public void updateGoodsSku(GoodsSku goodsSku) {
        goodsSkuMapper.updateByPrimaryKey(goodsSku);
    }

    @Override
    public List<GoodsSku> getGoodsSkuList(Map<String, Object> map) {
        GoodsSkuExample example = new GoodsSkuExample();
        GoodsSkuExample.Criteria criteria = example.createCriteria();

        if (MapUtils.getString(map, "name") != null) {
            criteria.andNameLike("%" +  MapUtils.getString(map, "name") + "%");
        }
        if (MapUtils.getInteger(map, "status") != null) {
            criteria.andStatusEqualTo(MapUtils.getInteger(map, "status") );
        } else {
            criteria.andStatusNotEqualTo(0);
        }
        if (MapUtils.getLong(map, "goodsId") != null) {
            criteria.andGoodsIdEqualTo(MapUtils.getLong(map, "goodsId") );
        }

        return goodsSkuMapper.selectByExample(example);
    }

    @Override
    public List<GoodsSku> getGoodsSkuList(Long goodsId) {
        GoodsSkuExample example = new GoodsSkuExample();
        GoodsSkuExample.Criteria criteria = example.createCriteria();
        criteria.andGoodsIdEqualTo(goodsId).andStatusEqualTo(1);

        return goodsSkuMapper.selectByExample(example);
    }

    @Override
    public GoodsSku findGoodsSkuById(Long id) {
        return goodsSkuMapper.selectByPrimaryKey(id);
    }
}
